%.gba : %.elf
	@echo "GBA_OBJCP $@"
	@$(OBJCOPY) -O binary $< $@
	@echo "GBAFIX $@"
	@$(GBAFIX) $@ -p -t EZStubs

%.sim_exec: %.gba
	$(VBA) $<

%.sim_gdb: %.elf make/gdb.init
	export searchdirs=`find $(SRC_DIR) -type d -not -regex '\..*test.*' -exec echo -n ' --directory {}' \;` ;\
	export searchdirs="--directory $(dir $@) $${searchdirs}"; \
	xterm -e $(GDB) $(GDBFLAGS) $${searchdirs} $<

%.sim_ddd: %.elf make/gdb.init
	export searchdirs=`find $(SRC_DIR) -type d -not -regex '\..*test.*' -exec echo -n ' --directory {}' \;` ;\
	export searchdirs="--directory $(dir $@) $${searchdirs}"; \
	xterm -e ddd --debugger $(GDB) $(GDBFLAGS) $${searchdirs} $<

%.target_exec: %.bin
	@echo "TRANSMIT  $@"
	@echo
	@$(RCXFIRMDL) --fast --tty=$(RCXTTY) -s $<

%.target_debug: %.bin
	@echo "Not available!"

# these targets are to be used by the testrunner only

%.sim_run: %.elf
	$(GDB) --command $*.gdb $< > $*.log

%.target_run: %.elf
	@echo "Not yet implemented!"