/* -*- c++ -*- ***************************************************************/
/* Echtzeitsysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                              C H A I N                                    */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Verkettungszeiger zum Einfuegen eines Objektes in eine einfach verkettete */
/* Liste.                                                                    */
/*****************************************************************************/

#ifndef __chain_include__
#define __chain_include__

/**
 * \class Chain
 * \brief The basic elements for single linked data structures.
 **/
class Chain {
 public:

  /**
   * \brief Pointer to the next element
   **/
  Chain* next;

  /**
   * \brief Is the element already part of some data structure?
   * \retval true The element already is part of some data structure.
   * \retval false The element is not part of any data structure so far.
   **/
  bool chained() { return next != 0; }
};

#endif

