/* -*- c++ -*- ***************************************************************/
/* Echtzeitsysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                       T H R E A D _ S T A C K                             */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Kontrollflussabstraktion mit einem eigenen Stack.                         */
/*****************************************************************************/

#ifndef __thread_stack_h__
#define __thread_stack_h__

#include "thread/scheduler_thread.h"

/**
 * \class Thread_Stack
 * \brief A thread having an own stack
 **/
class Thread_Stack : public Scheduler_Thread {
         
public:

  /**
   * \brief Constructor
   * \param tos A pointer to the top of the threads stack
   **/
  Thread_Stack(void* tos) : Scheduler_Thread(tos) {}

  /**
   * \brief Destructor
   *
   * Only needed to prevent compiler warnings due to virtual methods
   **/
  virtual ~Thread_Stack() {}
};

#endif /* __thread_stack_h__ */
